/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the Reminder type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Reminder{}

// Reminder struct for Reminder
type Reminder struct {
	Message *Message `json:"message,omitempty"`
	ExtendWait *string `json:"extend_wait,omitempty"`
}

// NewReminder instantiates a new Reminder object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReminder() *Reminder {
	this := Reminder{}
	return &this
}

// NewReminderWithDefaults instantiates a new Reminder object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReminderWithDefaults() *Reminder {
	this := Reminder{}
	return &this
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *Reminder) GetMessage() Message {
	if o == nil || IsNil(o.Message) {
		var ret Message
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Reminder) GetMessageOk() (*Message, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *Reminder) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given Message and assigns it to the Message field.
func (o *Reminder) SetMessage(v Message) {
	o.Message = &v
}

// GetExtendWait returns the ExtendWait field value if set, zero value otherwise.
func (o *Reminder) GetExtendWait() string {
	if o == nil || IsNil(o.ExtendWait) {
		var ret string
		return ret
	}
	return *o.ExtendWait
}

// GetExtendWaitOk returns a tuple with the ExtendWait field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Reminder) GetExtendWaitOk() (*string, bool) {
	if o == nil || IsNil(o.ExtendWait) {
		return nil, false
	}
	return o.ExtendWait, true
}

// HasExtendWait returns a boolean if a field has been set.
func (o *Reminder) HasExtendWait() bool {
	if o != nil && !IsNil(o.ExtendWait) {
		return true
	}

	return false
}

// SetExtendWait gets a reference to the given string and assigns it to the ExtendWait field.
func (o *Reminder) SetExtendWait(v string) {
	o.ExtendWait = &v
}

func (o Reminder) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Reminder) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	if !IsNil(o.ExtendWait) {
		toSerialize["extend_wait"] = o.ExtendWait
	}
	return toSerialize, nil
}

type NullableReminder struct {
	value *Reminder
	isSet bool
}

func (v NullableReminder) Get() *Reminder {
	return v.value
}

func (v *NullableReminder) Set(val *Reminder) {
	v.value = val
	v.isSet = true
}

func (v NullableReminder) IsSet() bool {
	return v.isSet
}

func (v *NullableReminder) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReminder(val *Reminder) *NullableReminder {
	return &NullableReminder{value: val, isSet: true}
}

func (v NullableReminder) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReminder) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


